#ifndef _MIDI_H
#define _MIDI_H	1

/***************************************************************************
 * MIDI values that are independent of any particular synthesizer.
 ***************************************************************************/

/***************************************************************************
 * Some system-exclusive message constants.
 ***************************************************************************/

#define	SYSEX_BEGIN	0xF0
#define	SYSEX_END	0xF7

/***************************************************************************
 * Allow use of MIDI interfaces not attached to the internal serial port,
 * unit 0.  Here are the defaults.
 ***************************************************************************/

#define	DEFAULT_MIDI_DEVICE	"serial.device"
#define	DEFAULT_MIDI_UNIT	0
#define	MIDI_ENV_VAR		"MP_MIDI_DEVICE"

#define	MIDI_BAUD_RATE		31250

#ifndef CTRL_C_NO_BYTES
#define CTRL_C_NO_BYTES		(-1)
#endif

/***************************************************************************
 * End of this header file.
 ***************************************************************************/

#endif /* _MIDI_H */
