#ifndef _MIDI_H
#define _MIDI_H	1

/**************************************************************************
* midi.h:	MIDI values that are independent of any particular synth.
*		A part of OberSuite for the Commodore Amiga.
*
* Author:	Daniel Barrett, barrett@cs.umass.edu.
* Version:	1.0.
* Copyright:	None!  This program is in the Public Domain.
*		Please share it with others.
***************************************************************************/

/***************************************************************************
 * Some system-exclusive message constants.
 ***************************************************************************/

#define	SYSEX_BEGIN	0xF0
#define	SYSEX_END	0xF7

/***************************************************************************
* The MIDI baud rate.
***************************************************************************/

#define	MIDI_BAUD_RATE		31250

/***************************************************************************
 * By default, we assume that the MIDI interface is attached to the Amiga's
 * internal serial port, using "serial.device" unit 0.
 ***************************************************************************/

#define	DEFAULT_MIDI_DEVICE	"serial.device"
#define	DEFAULT_MIDI_UNIT	0


#endif /* _MIDI_H */
