#ifndef _OBEXTRACT_H
#define _OBEXTRACT_H 1

/**************************************************************************
* obextract.h:	Specific definitions for ObExtract.
*		A part of OberSuite for the Commodore Amiga.
*
* Author:	Daniel Barrett, barrett@cs.umass.edu.
* Version:	1.0.
* Copyright:	None!  This program is in the Public Domain.
*		Please share it with others.
***************************************************************************/

/***************************************************************************
* Program version.
***************************************************************************/

#define VERSION		"1.03"
#define	VERDATE		"(21.1.93)"

/***************************************************************************
* Macros for generating names for extracted patch files.
***************************************************************************/

#define	DEFAULT_FILENAME_CHAR	'_'
#define	DEFAULT_PATCH_NAME	"No_Name"

/***************************************************************************
* Global variables.
***************************************************************************/

extern char programName[];
extern int thePrintStyle;
int theDestination;		/* Bitfield -- 1, 2, 4, 8, 16, ... */
BOOL overwriteAll;
BOOL useTheRealNames;

/***************************************************************************
* Prototypes.
***************************************************************************/

void ComputeLowAndHigh(BITS numbers[], UBYTE *low, UBYTE *high);
BOOL DoTheExtract(PATCHINFO *pi, BITS numbers[], char *filename);
BOOL ExtractOneToFile(PATCHINFO *pi, long offset, char *infile);
BOOL ExtractOneToSynth(PATCHINFO *pi, long offset);
void MakePatchFileName(char *outfile, char *orig, PATCHINFO *pi, long offs);
void ObExtract(BITS numbers[], char *filename);
int  ReadRanges(BITS numbers[], int firstArg, char *argv[]);
char *PatchnameToFilename(PATCHINFO *pi, long offset);


/***************************************************************************
* Stuff for getopt().
***************************************************************************/

static char *options = "qQlofar";


#endif /* _OBEXTRACT_H */

