#ifndef _OBTYPE_H
#define _OBTYPE_H 1

/**************************************************************************
* obtype.h:	Specific definitions for ObType.
*		A part of OberSuite for the Commodore Amiga.
*
* Author:	Daniel Barrett, barrett@cs.umass.edu.
* Version:	1.0.
* Copyright:	None!  This program is in the Public Domain.
*		Please share it with others.
***************************************************************************/

/***************************************************************************
* Program version.
***************************************************************************/

#define VERSION		"1.03"
#define	VERDATE		"(21.1.93)"


/***************************************************************************
* Macros for the spacing of output.
***************************************************************************/

#define	NAME_BUFFER_LENGTH	((NAME_LENGTH * 2) + 1)
#define	NAMES_PER_ROW		5
#define	SPACE_BETWEEN_NAMES	"   "
#define	SPACE_AFTER_LABEL	" "

/***************************************************************************
* Prototypes.
***************************************************************************/

void	ObType(char *filename);
void	PrintHeader(PATCHINFO *pi, char *filename);
void	PrintNames(void (*fcn)(), PATCHINFO *pi);
void	PrintStuff(PATCHINFO *pi, char *filename);
void	PrintStuffNicely(PATCHINFO *pi, long offset, int counter);
void	PrintStuffBriefly(PATCHINFO *pi, long offset, int counter);
void	PrintStuffLong(PATCHINFO *pi, long offset, int counter);
char	PatchTypeLetter(UBYTE *patch);
void	VerifyStuffOnly(PATCHINFO *pi, long offset, int counter);
	
/***************************************************************************
* Global variables.
***************************************************************************/

extern char programName[];
extern int thePrintStyle;

/***************************************************************************
* Stuff for getopt().
***************************************************************************/

static char *options = "qsml";


#endif /* _OBTYPE_H */
