#ifndef _PATCHINFO_H
#define _PATCHINFO_H	1

/**************************************************************************
* patchinfo.h:	The PATCHINFO structure definitions.
*		A part of OberSuite for the Commodore Amiga.
*
* Author:	Daniel Barrett, barrett@cs.umass.edu.
* Version:	1.0.
* Copyright:	None!  This program is in the Public Domain.
*		Please share it with others.
***************************************************************************/

#include "decl.h"


#define	INFO_STRING_LEN		20
#define	PI_SOURCE_FILE		1
#define	PI_SOURCE_MIDI		2

struct patchInfo
{
	UBYTE	*data;				/* The patch data itself. */
	UBYTE	mode;				/* SINGLE_DATA, MULTI_DATA */
	UBYTE	patchNum;			/* Desired patch number. */
	int	source;				/* SOURCE_FILE, SOURCE_MIDI. */
	long	rightSize;			/* Correct # data bytes. */
	long	actualSize;			/* Actual # data bytes. */
	long	numPatches;			/* How many patches to get. */
	long	numSinglesInside;		/* # singles in a multipatch */
	long	nameOffset;			/* 1st byte of patch name. */
	long	firstSingleOffset;		/* 1st byte of single patch
						 * numbers found in a multi. */
	char	instrument[INFO_STRING_LEN];	/* English name. */
	char	modeName[INFO_STRING_LEN];	/* "single", "multi" */
};
typedef struct patchInfo PATCHINFO;


#endif	/*  _PATCHINFO_H */
